#include <stdio.h>
#include <mysql/mysql.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "confread.h"

#define PREFIX "/usr/local/mmc"
#define ROOTBOXDIR PREFIX "/boxes"
#define VIRTFILE PREFIX "/etc/virtusertable"

#define DBCONF PREFIX "/etc/db.conf"
#define MAILSRVCONF PREFIX "/etc/mailsrv.conf"

int main() {

    MYSQL *dbs=NULL;
    MYSQL_RES *result=NULL;
    MYSQL_ROW myrow=NULL;
    char **domains=NULL;
    char **sdomains=NULL;
    char *dotmark=NULL;
    char *mydomain=NULL;
    int i=0,j=0,k=0;
    char buildquery[2048];
    char salt[3];
    char *dbfilename=NULL;
    struct stat filestat;
    char filename[2048];
    char tfilename[2048];
    FILE *authfile;
    FILE *virtuserfile;
    char *mysqlhost, *mysqluser, *mysqlpass;
    char *myhostname, *deliveryuser, *mailboxuid, *mailboxgid;

    if((mysqlhost = readconf(DBCONF, "DBSERVER")) == NULL) {
        printf("Could not read 'DBSERVER' from %s.\n", DBCONF);
        return 1;
    }
                            
    if((mysqluser = readconf(DBCONF, "USERNAME")) == NULL) {
        printf("Could not read 'USERNAME' from %s.\n", DBCONF);
        return 2;
    }
                                                        
    if((mysqlpass = readconf(DBCONF, "PASSWORD")) == NULL) {
        printf("Could not read 'PASSWORD' from %s.\n", DBCONF);
        return 3;
    }
    
    if((myhostname = readconf(MAILSRVCONF, "HOSTNAME")) == NULL) {
        printf("Could not read 'HOSTNAME' from %s.\n", MAILSRVCONF);
        return 4;
    }
    
    if((deliveryuser = readconf(MAILSRVCONF, "DELIVERY")) == NULL) {
        printf("Could not read 'DELIVERY' from %s.\n", MAILSRVCONF);
        return 5;
    }
    
    if((mailboxuid = readconf(MAILSRVCONF, "MAILBOXUID")) == NULL) {
        printf("Could not read 'MAILBOXUID' from %s.\n", MAILSRVCONF);
        return 6;
    }
    
    if((mailboxgid = readconf(MAILSRVCONF, "MAILBOXGID")) == NULL) {
        printf("Could not read 'MAILBOXGID' from %s.\n", MAILSRVCONF);
        return 7;
    }
    
    if((dbs = mysql_init(NULL))!=NULL) {
        if(mysql_real_connect(dbs, mysqlhost, mysqluser, mysqlpass, NULL, 0, NULL, 0)) {
            if(!mysql_select_db(dbs, "mmcadmin")) {
                if(!mysql_query(dbs, "SELECT pdomain,sdomains FROM customers")) {
                    result = mysql_use_result(dbs);
                    
                    while(myrow = mysql_fetch_row(result)) {
                        domains=realloc(domains, ((i+1)*sizeof(char *)) );
                        *(domains+i)=strdup(myrow[0]);
                        sdomains=realloc(sdomains, ((i+1)*sizeof(char *)) );
                        *(sdomains+i)=strdup(myrow[1]);
                        i++;
                    }
                    
                    if(domains) {
                        if(!mysql_select_db(dbs, "mmccust")) {
                            
                            virtuserfile = fopen(VIRTFILE, "w+");

                            for(j=0;j<i;j++) {
                                printf("%s: %s(%p)\n", *(domains+j), *(sdomains+j), *(sdomains+j));
                                
                                /* Check and create directories as necessary */
                                snprintf(filename, 2048, "%s/%s", ROOTBOXDIR, *(domains+j));
                                if(!stat(filename, &filestat)) {
                                    printf("'%s' already exists.  Skipping.\n",filename);
                                    
                                    /* Check for each symlink for secondary domains */
                                    
                                    if( strlen(*(sdomains+j)) ) {
                                        mydomain = strtok( *(sdomains+j), "\r\n, " );
                                        do {
                                            fprintf(virtuserfile,"@%s	\%1@%s\n", mydomain, *(domains+j));
#if 0                                            
                                            snprintf(tfilename, 2048, "%s/%s", ROOTBOXDIR, mydomain);
                                            if(stat(tfilename, &filestat)) {
                                                if(symlink(filename, tfilename)) printf("Could not create link %s -> %s\n", tfilename, filename);
                                                else printf("Sucessfully created link %s -> %s\n", tfilename, filename);
                                            } else printf("'%s' already exists.  Skipping.\n",tfilename);
#endif                                            
                                        } while( (mydomain = strtok( NULL, "\r\n, " )) != NULL );
                                    } 
                                    
                                    snprintf(filename, 2048, "%s/%s/auth", ROOTBOXDIR, *(domains+j));
                                    if(stat(filename, &filestat)) {
                                        printf("'%s' does not exist.  Creating.\n",filename);
                                        mkdir(filename, 0x01FF);  /* ~umask & o777 */ 
                                    } else printf("'%s' already exists.  Skipping.\n",filename);
                                    
                                    snprintf(filename, 2048, "%s/%s/mail", ROOTBOXDIR, *(domains+j));   
                                    if(stat(filename, &filestat)) {
                                        printf("'%s' does not exist.  Creating.\n",filename);  
                                        mkdir(filename, 0x01FF);  /* ~umask & o777 */
                                    } else printf("'%s' already exists.  Skipping.\n",filename);  
                                } else {
                                    printf("'%s' does not exist.  Creating.\n",filename);
                                    
                                    mkdir(filename, 0x01FF);  /* ~umask & o777 */
                                    
                                    /* Create symlinks for secondary domains. */

                                    if( strlen(*(sdomains+j)) ) {
                                        mydomain = strtok( *(sdomains+j), "\r\n, " );
                                        do {
                                            fprintf(virtuserfile,"@%s	\%1@%s\n", mydomain, *(domains+j));
#if 0                                            
                                            snprintf(tfilename, 2048, "%s/%s", ROOTBOXDIR, mydomain);
                                            if(stat(tfilename, &filestat)) {
                                                if(symlink(filename, tfilename)) printf("Could not create link %s -> %s\n", tfilename, filename);
                                                else printf("Sucessfully created link %s -> %s\n", tfilename, filename);
                                            } else printf("'%s' already exists.  Skipping.\n",tfilename);
#endif                                  
                                        } while( (mydomain = strtok( NULL, "\r\n, " )) != NULL );
                                    } 

                                    /* Also create the other two directories */
                                    
                                    snprintf(filename, 2048, "%s/%s/auth", ROOTBOXDIR, *(domains+j));
                                    mkdir(filename, 0x01FF);  /* ~umask & o777 */
                                    
                                    snprintf(filename, 2048, "%s/%s/mail", ROOTBOXDIR, *(domains+j));
                                    mkdir(filename, 0x01FF);  /* ~umask & o777 */
                                }

                                dbfilename=strdup(*(domains+j));

                                while( (dotmark = strchr(dbfilename, '.')) != NULL ) {
                                    *dotmark = '_';
                                }
                                
                                snprintf(buildquery, 2048, "SELECT username, password, aliases FROM %s_users", dbfilename );
                                if(!mysql_query(dbs, buildquery)) {
                                
                                    result = mysql_use_result(dbs);
                                
                                    while(myrow = mysql_fetch_row(result)) {
                                    
                                        snprintf(filename, 2048, "%s/%s/auth/%s", ROOTBOXDIR, *(domains+j), myrow[0]);
                                        
                                        if((authfile = fopen(filename, "w+")) != NULL) {
                                        
                                            salt[0]=(rand() % 26) + 65;
                                            salt[1]=(rand() % 26) + 97;
                                            salt[2]=0;
                                        
                                            fprintf(authfile, "%s:%s:%s:%s:::\n", myrow[0], crypt(myrow[1], &salt[0]), mailboxuid, mailboxgid);
                                            fclose(authfile);
                                            
                                            fprintf(virtuserfile,"%s@%s	%s@%s\n",myrow[0], *(domains+j), deliveryuser, myhostname);
                                            if(strlen(myrow[2])) {
                                                mydomain = strtok(myrow[2], "\r\n, ");
                                                do {
                                                    fprintf(virtuserfile,"%s@%s	%s@%s\n", mydomain, *(domains+j), myrow[0], *(domains+j));
                                                } while( (mydomain=strtok(NULL, "\r\n, ")) != NULL );
                                            }
                                        } else printf("Could not open auth file '%s'\n",filename);
                                    }
                                    
                                } else puts("Could not query users list.");
                                
                                free(dbfilename);
                            }
                            
                            fclose(virtuserfile);

                        } else puts("Could not change domains.");
                    } else puts("No domains found.");
                } else puts("Customer lookup failed.");
            } else puts("Could not select the 'mmcadmin' database.");
        } else puts("Could not connect to the database.");
    
        mysql_close(dbs);    
    } else puts("Could not allocate memory for connect.");

    return 0;

}